﻿using GovDataVisApp.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;

namespace GovDataVisApp.Converters
{
    public class NoResultsFoundConverter : IValueConverter 
    {
        private MapSearchViewModel _mapSearch = null;

        public NoResultsFoundConverter()
        {
            MapSearchViewModel _mapSearch = App.MapSearch;
        }

        public object Convert(object value, Type targetType, object parameter, string language)
        {
           return (!this.MapSearch.IsWorking && this.MapSearch.QueryComplete && this.MapSearch.SearchResults.Count == 0);
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }

        public MapSearchViewModel MapSearch
        {
            get
            {
                if (this._mapSearch == null)
                {
                    this._mapSearch = App.MapSearch;
                }
                return this._mapSearch;
            }
        }
    }
}
