﻿using Bing.Maps;
using GovDataVisApp.Models;
using GovDataVisApp.ViewModels;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Devices.Geolocation;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace GovDataVisApp
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.DataContext = App.MapSearch;

            this.InitializeComponent();
        }

        // recommendation from http://channel9.msdn.com/Shows/Inside+Windows+Phone/Practical-MVVM-For-Windows-Phone
        private MapSearchViewModel _viewModel { get { return this.DataContext as MapSearchViewModel; } }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void myMap_Tapped(object sender, TappedRoutedEventArgs e)
        {
            MapSearchResult result = this.CurrentResult(e.OriginalSource as FrameworkElement);
            // ensures we don't show the search box when a pin is tapped
            if (result == null && !this._viewModel.IsWorking)
            {
                Point p = e.GetPosition(this.myMap);
                Location location = new Location();
                myMap.TryPixelToLocation(p, out location);

                this._viewModel.Query.Text = string.Empty;
                this._viewModel.Query.Radius = 20;
                // set the lat lon values
                this._viewModel.Query.Latitude = location.Latitude;
                this._viewModel.Query.Longitude = location.Longitude;

                // show the item search window
                searchInput.HorizontalOffset = p.X;
                searchInput.VerticalOffset = p.Y;

                if (itemDetails.IsOpen) { itemDetails.IsOpen = false; }
                if (!searchInput.IsOpen) { searchInput.IsOpen = true; }
            }
        }

        private void pushpin_Clicked(object sender, PointerRoutedEventArgs e)
        {
            Point p = e.GetCurrentPoint(this.myMap).Position;
            this._viewModel.SelectedResult = this.CurrentResult(e.OriginalSource as FrameworkElement);


            itemDetails.HorizontalOffset = p.X - 100;
            itemDetails.VerticalOffset = p.Y - 160;

            if (searchInput.IsOpen) { searchInput.IsOpen = false; }
            if (!itemDetails.IsOpen) { itemDetails.IsOpen = true; }
        }

        private MapSearchResult CurrentResult(FrameworkElement element)
        {
            if (element == null)
            {
                return null;
            }
            return ((FrameworkElement)element).DataContext as MapSearchResult;
        }
    }
}
