﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace GovDataVisApp.Models
{
    public class MapQuery : INotifyPropertyChanged
    {

        private string _text;
        public string Text
        {
            get { return this._text; }
            set
            {
                this._text = value;
                this.NotifyPropertyChanged();
            }
        }

        private double _latitude;
        public double Latitude
        {
            get { return this._latitude; }
            set
            {
                this._latitude = value;
                this.NotifyPropertyChanged();
            }
        }

        private double _longitude;
        public double Longitude
        {
            get { return this._longitude; }
            set
            {
                this._longitude = value;
                this.NotifyPropertyChanged();
            }
        }

        private double _radius;
        public double Radius
        {
            get { return this._radius; }
            set
            {
                this._radius = value;
                this.NotifyPropertyChanged();
            }
        }

        // pulled from the msdn wp8 twitter sample: http://code.msdn.microsoft.com/wpapps/TwitterSearch-Windows-b7fc4e5e
        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged([CallerMemberName] string propertyName = "")
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
